#include <stdio.h>
#include <stdlib.h>

struct cliente {
       char cognome[30],nome[30];
       int codice,categoria;
       };
struct atomo {
       struct cliente dato;
       struct atomo *next;
       };
       
struct prodotto {
       int cliente,codice,tipo;
       float importo;
       };
void in_testa(struct atomo *L[3], struct cliente c)
{
     struct atomo *aux;
     int i;
     
     i=c.categoria;
     
     aux=malloc(sizeof(struct atomo));
     if(aux)
      
        {   aux->dato=c;
            aux->next=L[i];
            L[i]=aux;
        }
}

void elimina(struct atomo *L[3])
{
     int cliente,i;
     struct atomo *l1,*l2;
     
     
     printf("Categoria ");
     scanf("%d",&i);
     printf("Codice cliente ");
     scanf("%d",&cliente);
     
     if(L[i]==NULL)
       { printf("Lista vuota\n");
         return;
         }
     if(L[i]->dato.codice == cliente)
     /* elimina dalla testa */
     {  l1=L[i];
        L[i]=l1->next;
        printf("Cognome %s\n",l1->dato.cognome);
        printf("Nome %s\n",l1->dato.nome);
        free(l1);
        return;
     }
     l2=L[i];
     l1=l2->next;
     while(l1!=NULL)
       if(l1->dato.codice==cliente)
        /* trovato */
        {l2->next=l1->next;
         printf("Cognome %s\n",l1->dato.cognome);
         printf("Nome %s\n",l1->dato.nome);
         free(l1);
         return;
        }
       else { l1=l1->next;
              l2=l2->next;
            }
     printf("Non trovato\n");
}

void ins_prodotto(struct prodotto *T[6], int N[6])
{
     struct prodotto p;
     int i;
     struct prodotto *aux;
     
     printf("Codice cliente ");
     scanf("%d",&p.cliente);
     printf("Codice prodotto ");
     scanf("%d",&p.codice);
     printf("Importo ");
     scanf("%f",&p.importo);
     printf("Tipo ");
     scanf("%d",&p.tipo);
     i=p.tipo;
     aux=realloc(T[i],sizeof(struct prodotto)*(N[i]+1));
     if(aux)
       {
            T[i]=aux;
            T[i][N[i]]=p;
            N[i]++;
       }
      else printf("Memoria non allocata\n");
}

void visualizza(struct prodotto *T[6],int N[6])
{
     int i,j;
     
     
     for(i=0;i<6;i++)
      for(j=0;j<N[i];j++)
        { printf("Codice cliente %d\n",T[i][j].cliente);
          printf("Codice prodotto %d\n",T[i][j].codice);
          printf("Importo %f\n\n",T[i][j].importo);
        }              
}

void salva(struct prodotto *T[6], int N[6])
{
     int cliente;
     int i,j;
     FILE *pf;
     
     
     printf("Codice cliente ");
     scanf("%d",&cliente);
     
     pf=fopen("prodotti.txt","w");
     if(pf)
       {
           for(i=0;i<6;i++)
             for(j=0;j<N[i];j++)
              if(T[i][j].cliente==cliente)
                fwrite(&T[i][j],sizeof(struct prodotto),1,pf);
           fclose(pf);
       }
      else printf("errore\n");
}

void inizializza(struct prodotto *T[6], int N[6])
{
     FILE *pf;
     struct prodotto p;
     int i;
     struct prodotto *aux;
     
     pf=fopen("prodotti.txt","r");
     if(pf)
       {
          while(fread(&p,sizeof(struct prodotto),1,pf))
            {
              i=p.tipo;
              aux=realloc(T[i],sizeof(struct prodotto)*(N[i]+1));
              if(aux)
                {  T[i]=aux;
                   T[i][N[i]]=p;
                   N[i]++;
                }
              }               
          fclose(pf);
       }
      else printf("Il file e' vuoto\n");
}         
 
 
main() {
       
struct atomo *L[3];
struct prodotto *T[6];
int N[6];
struct cliente cl;
int scelta, i;
struct atomo *aux;
       
       
/* Inizializzazione */
   for(i=0;i<3;i++)
     L[i]=NULL;
     
   for(i=0;i<6;i++)
    {
     T[i]=NULL;
     N[i]=0;
    }
    inizializza(T,N);
    
    do {
        printf("\nScegli tra \n");
        printf("1) Ins. in lista\n");
        printf("2) Elimina dalla lista\n");
        printf("3) Ins. prodotto\n");
        printf("4) Visualizza prodotti\n");
        printf("5) Salva i prodotti di un cliente\n");
        printf("0) Fine\n");
        scanf("%d",&scelta);
        switch(scelta) {
           case 1: printf("Cognome ");
                   scanf("%s",cl.cognome);
                   printf("Nome ");
                   scanf("%s",cl.nome);
                   printf("Codice cliente ");
                   scanf("%d",&cl.codice);
                   printf("Categoria (0,1,2) ");
                   scanf("%d",&cl.categoria);
                   in_testa(L,cl);
                   break;
           case 2: elimina(L);
                   break;
           case 3: ins_prodotto(T,N);
                   break;
           case 4: visualizza(T,N);
                   break;
           case 5: salva(T,N);
                   break;
           default:; }
           } while(scelta!=0);
        
        /* liberiaamo la memoria*/
        
        for(i=0;i<6;i++)
          free(T[i]);
          
        for(i=0;i<3;i++)
         while(L[i]!=NULL)
          {
            aux=L[i];
            L[i]=aux->next;
            free(aux);
          }
}          
     
     
     
       
